{
               Delete EXt   -  waste file deleter
               -------------------------------------
               Version      :  2.60
               Code name    :  Powerful Waste Cleaner
               Last Created :  1995/08/19
               Enviroment   :  anywhere
               Function     :  delete waste files
               Production   :  KIM, JIN HONG (AROMANIX)
               -------------------------------------
}

{$M 8192,0,0}
uses
  Crt, Dos, Option;

var
  Opt:string;
  NASK,ALLHARD,SAVE:boolean;
  TFile,TDrive,TDeleted,TSkipped:word;

  ERSCOUNT:array[1..26] of word;
  EXTDATA :array[1..50] of string[3];
  DRVDATA :array[1..26] of char;


procedure Sounds(H,D,AD:word);
begin
  sound(H);
  delay(D);
  nosound;
  delay(AD)
end;

PROCEDURE Print(S:string;C,BC:byte;NL:boolean);
begin
  textattr:=C+BC*16;
  write(S);
  textattr:=7;
  if NL then writeln
end;

FUNCTION Ask(S:string):boolean;
begin
  sounds(3000,20,0);

  write('Delete? [',S,'] (y/N) ');
  case upcase(readkey) of
    #27:begin
          Print('STOP',12,0,true);
          halt
    end;
    'Y':begin
          Print('Yes',15,0,true);
          Ask:=true
    end
    else begin
           inc(TSkipped);
           Print('No',15,0,true);
           Ask:=false
    end
  end
end;

PROCEDURE Ers(P:string);
var F:file;
begin
  assign(F,P);
  erase(F);
  if NASK then writeln(P);
  inc(ERSCOUNT[ord(P[1])-64]);
  inc(TDeleted)
end;

FUNCTION FKeyPressed:boolean; assembler;
ASM
  PUSH DS
  MOV AX, 40h
  MOV DS, AX
  CLI
  MOV AX, [1Ah]
  CMP AX, [1Ch]
  STI
  MOV AX, 0
  JZ @NoPress
  INC AX
  @NoPress:
  POP DS
END;

PROCEDURE Sd(P:string);
var D:searchrec;
    PO,T:byte;
begin
  findfirst(P+'\*.*',anyfile,D);

  if doserror<>0 then begin
    Print('Error! Skip the drive '+P,4,0,true);
    sounds(200,100,30);
    sounds(300,50,0);
    exit
  end;

  while doserror=0 do begin
    if (FKeyPressed) and (readkey=#27) then halt;

    if (D.attr and directory<>0)
      and (D.name<>'.') and (D.name<>'..') then Sd(P+'\'+D.name);

    PO:=pos('.',D.name);

    if (PO<>0) and (D.attr and directory=0) then
      for T:=1 to TFile do
        if (EXTDATA[T]=copy(D.name,PO+1,length(D.name)-PO))
        and ((NASK) or (Ask(P+'\'+D.name))) then Ers(P+'\'+D.name);

    findnext(D)
  end
end;

procedure Help;
begin
    Print('USAGE   DEX [ext] [ext].. [drive:] [/N]o standby [/A]ll HDDs [/S]ave the list',7,0,true);
    Print('EXAMPLE C:\>DEX $$$ BAK TMP D: C:',7,0,true);
    Print('RESULT  *.$$$, *.BAK, *.TMP files are deleted in drive C: & D:',7,0,true);
    Print('NOTE    Press ESC to stop whenever.',7,0,true);
    Print('        Please read DEX.DOC for more information!',7,0,true);
    halt
end;

function getdrivenum:byte;
begin
   asm
     mov        ah,     8h
     mov        cx,     0
     mov        dl,     80h
     int        13h
     mov        @Result, dl
   end;
end;

function PresentDrive:char;
begin
asm
  mov   ah,19h
  int   21h
  add   al,65
  mov   @Result,al
end
end;

var
  T,I:word;
  S:string;
begin
  writeln;
  Print('Delete EXt 2.6.0  (c) 1993-1995 KIM, JIN HONG (aromanix)            COREA',15,3,true);
  if paramcount=0 then Help;

  { variables setting }
  Opt         :=ucase(getparameters);
  NASK        :=checkstr(Opt,'/N',false);
  ALLHARD     :=checkstr(opt,'/A',false);
  SAVE        :=checkstr(opt,'/S',false);

  TDeleted:=0;
  TSkipped:=0;
  TFile:=0;
  TDrive:=0;
  fillchar(ERSCOUNT[1],sizeof(ERSCOUNT),0);


  { find targets }
  I:=getpathnum(opt,false);

  for T:=1 to I do begin
    s:=getpath(opt,t,false);

    if (s[ord(s[0])]=':') and (s[1] in ['A'..'Z']) then begin
      inc(TDrive);
      DRVDATA[TDrive]:=s[1];
    end else begin
      inc(TFile);
      EXTDATA[TFile]:=s;
    end;
  end;

  if ALLHARD then begin
    TDrive:=getdrivenum;
    for t:=1 to tdrive do drvdata[t]:=chr(66+t);
  end;

  if TFile=0 then Help;
  if TFile>50 then TFile:=50;
  if TDrive=0 then begin
    inc(TDrive);
    DRVDATA[TDrive]:=PresentDrive;
  end;

  { print information }
  Print('DRIVE    ',0,7,false);
  for T:=1 to TDrive do write(' ',DRVDATA[T]); writeln;

  Print('EXTENSION',0,7,false);
  for T:=1 to TFile do write(' ',EXTDATA[T]); writeln;

  Print('STANDBY  ',0,7,false);
  if NASK then writeln(' NO') else writeln(' YES');

  Print('ALL HDDs ',0,7,false);
  if ALLHARD then writeln(' YES') else writeln(' NO');

  Print('SAVE LIST',0,7,false);
  if SAVE then writeln(' YES') else writeln(' NO');

  { main routine to search }
  for T:=1 to TDrive do begin
    if SAVE then begin
      write('Making file list of '+drvdata[t]+':');
      SwapVectors;
      exec(GetEnv('COMSPEC'), '/C dir '+drvdata[t]+':\*.*/s>'+
                  drvdata[t]+':\FILELIST.TXT');
      SwapVectors;
      gotoxy(1,wherey);
      clreol;
      if DosError <> 0 then begin
        writeln('Fatal Error: Could not execute COMMAND.COM');
        halt;
      end;
    end;

    writeln;
    write('Searching');
    textcolor(7+blink);
    write('... ');
    textcolor(7);
    writeln(DRVDATA[T],':');
    Sd(DRVDATA[T]+':')
  end;

  { result message }
  writeln;
  for T:=1 to TDrive do
    writeln('Drive ',DRVDATA[T],': ',ERSCOUNT[ord(DRVDATA[T])-64],' files deleted.');

  writeln;
  Print('Total ',10,0,false);
  writeln(TDeleted,' files deleted.');
  Print('Total ',11,0,false);
  writeln(TSkipped,' files skipped.')
end.
