{
               PARAMETER SEPARATOR
               --------------------------------------------------
               Version      :   2.60
               Unit name    :   Option
               Code name    :   Clever
               Last Created :   1995/08/19
               Enviroment   :   wherever
               Function     :   Parameter analysis, management
               Production   :   KIM, JIN HONG (AROMANIX)
               --------------------------------------------------
}

unit Option;

interface

const
  ParaSwitch:char='/';

function GetParameters:string;
function GetPath(Ins:string;Num:byte;AP:boolean):string;
function GetOption(Ins:string;Num:byte):string;
function UCase(S:string):string;
function CheckStr(Ins,Chk:string;UC:boolean):boolean;
function GetOptionNum(Ins:string):byte;
function GetPathNum(Ins:string;AP:boolean):byte; { ap means 'allow para' }
function GetFollow(Ins,Opt:string;UC,ALL:boolean):string;

implementation

function GetParameters:string;
var S:string;
    T:byte;
begin
  S:='';
  for T:=1 to mem[prefixseg:$80] do S:=S+chr(mem[PreFixSeg:T+$80]);
  GetParameters:=S
end;

function GetPath(Ins:string;Num:byte;ap:boolean):string;
var T,L,Index:byte;
    S:string;
begin
  Index:=0;
  S:='';
  T:=1;
  L:=length(Ins);

  while T<=L do begin

    if ins[t]=' ' then while (Ins[t]=' ') and (T<=L) do inc(t);
    if T>L then break;
    if (ins[t]=ParaSwitch) and (ap) then
      while (Ins[T]<>' ') and (T<=L) do inc(T)
    else begin
           inc(Index);
           if Index<>Num then while (Ins[T]<>' ') and (T<=L) do inc(T)
    end;

    if Index=Num then begin
      while (Ins[T]<>' ') and (T<=L) and ((not ap) or (Ins[T]<>ParaSwitch)) do begin
        S:=S+Ins[T];
        inc(T);
      end;
      break
    end

  end;
  GetPath:=S
end;

function GetOption(Ins:string;Num:byte):string;
var T,I,L:byte;
    S:string;
begin
  I:=0;
  S:='';
  L:=length(Ins);

  for T:=1 to L do
    if Ins[T]=ParaSwitch then begin
      inc(I);
      if I=Num then break
    end;

  while (I>0) and (Ins[T]<>' ') and (T<=L) do begin
    S:=S+Ins[T];
    inc(T);
    if Ins[T]=ParaSwitch then break
  end;

  GetOption:=S
end;

function UCase(S:string):string;
var T:byte;
begin
  for T:=1 to length(S) do S[T]:=upcase(S[T]);
  UCase:=S
end;

function CheckStr(Ins,Chk:string;UC:boolean):boolean;
var T,L:byte;
    C:boolean;
begin
  if UC then Ins:=UCase(Ins);
  C:=false;
  L:=length(ins);
  for T:=1 to L do
    if (Ins[T]=Chk[1]) and (copy(Ins,T,length(Chk))=Chk) then C:=true;
  CheckStr:=C
end;

function GetOptionNum(Ins:string):byte;
var T,C,L:byte;
begin
  C:=0;
  L:=length(Ins);
  for T:=1 to L do if Ins[T]=ParaSwitch then inc(C);
  GetOptionNum:=C
end;

function GetPathNum(Ins:string;ap:boolean):byte;
var T,C,L:byte;
begin
  C:=0;
  T:=1;
  L:=length(Ins);

  while T<=L do begin

    if ins[t]=' ' then while (Ins[t]=' ') and (T<=L) do inc(t);
    if T>L then break;
    if (ins[t]=ParaSwitch) and (ap) then while (Ins[T]<>' ') and (T<=L) do inc(T)
    else begin
           inc(C);
           while (Ins[T]<>' ') and (T<=L) do inc(T)
    end;

  end;

  GetPathNum:=C
end;

function GetFollow(Ins,Opt:string;UC,all:boolean):string;
var T,L:byte;
    S:string;
begin
  if UC then Ins:=UCase(Ins);
  T:=pos(Opt,Ins);
  S:='';

  if T=0 then begin
    GetFollow:='';
    exit
  end;

  inc(T,length(Opt));
  L:=length(Ins);

  while ((all) or ((Ins[T]<>' ') and (Ins[T]<>ParaSwitch)))
        and (T<=L) do begin
    S:=S+Ins[T];
    inc(T)
  end;

  GetFollow:=S
end;

end.

